import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
var _excluded = ["className", "style", "themeVars", "tag", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { useMemo } from 'react';
import ConfigProviderContext, { INITIAL_STATE } from './ConfigProviderContext';

function kebabCase(str) {
  return str.replace(/([A-Z])/g, '-$1').toLowerCase().replace(/^-/, '');
}

function mapThemeVarsToCSSVars(themeVars) {
  var cssVars = {};
  Object.keys(themeVars).forEach(function (key) {
    cssVars["--rc-".concat(kebabCase(key))] = themeVars[key];
  });
  return cssVars;
}

var ConfigProvider = function ConfigProvider(_ref) {
  var className = _ref.className,
      style = _ref.style,
      themeVars = _ref.themeVars,
      tag = _ref.tag,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, _excluded);

  var varStyle = useMemo(function () {
    if (themeVars) {
      return _objectSpread(_objectSpread({}, style), mapThemeVarsToCSSVars(themeVars));
    }

    return style;
  }, [themeVars]);
  return /*#__PURE__*/React.createElement(ConfigProviderContext.Provider, {
    value: _objectSpread(_objectSpread({}, INITIAL_STATE), props)
  }, /*#__PURE__*/React.createElement(tag, {
    className: className,
    style: varStyle
  }, children));
};

ConfigProvider.defaultProps = {
  tag: 'div'
};
export default ConfigProvider;