import _extends from "@babel/runtime/helpers/esm/extends";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
var _excluded = ["style", "className", "span", "children", "flex"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { useContext } from 'react';
import classnames from 'classnames';
import FlexContext from './FlexContext';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';

var FlexItem = function FlexItem(props) {
  var _useContext = useContext(ConfigProviderContext),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('flexitem', prefixCls),
      _createNamespace2 = _slicedToArray(_createNamespace, 1),
      bem = _createNamespace2[0];

  var style = props.style,
      className = props.className,
      span = props.span,
      children = props.children,
      flex = props.flex,
      others = _objectWithoutProperties(props, _excluded);

  var classes = classnames(bem([span === null || span === void 0 ? void 0 : span.toString()]), className);

  var parseFlex = function parseFlex(_flex) {
    if (typeof _flex === 'number') {
      return "".concat(_flex, " ").concat(_flex, " auto");
    }

    if (/^\d+(\.\d+)?(px|em|rem|%)$/.test(_flex)) {
      return "0 0 ".concat(_flex);
    }

    return _flex;
  };

  return /*#__PURE__*/React.createElement(FlexContext.Consumer, null, function (_ref) {
    var gutter = _ref.gutter;

    var mergedStyle = _objectSpread({}, style);

    if (gutter) {
      mergedStyle = _objectSpread(_objectSpread(_objectSpread({}, gutter[0] > 0 ? {
        paddingLeft: gutter[0] / 2,
        paddingRight: gutter[0] / 2
      } : {}), gutter[1] > 0 ? {
        paddingTop: gutter[1] / 2,
        paddingBottom: gutter[1] / 2
      } : {}), mergedStyle);
    }

    if (flex) {
      mergedStyle.flex = parseFlex(flex);
    }

    return /*#__PURE__*/React.createElement("div", _extends({}, others, {
      style: mergedStyle,
      className: classes
    }), children);
  });
};

export default FlexItem;