import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";

/* eslint-disable @typescript-eslint/naming-convention */
import { useEffect, useState } from 'react';
import { inBrowser } from '../utils';
import useEventListener from './use-event-listener';
export function usePageVisibility() {
  var _useState = useState('visible'),
      _useState2 = _slicedToArray(_useState, 2),
      visibility = _useState2[0],
      _setVisibility = _useState2[1];

  var setVisibility = function setVisibility() {
    if (inBrowser) {
      _setVisibility(document.hidden ? 'hidden' : 'visible');
    }
  };

  useEffect(function () {
    setVisibility();
  }, []);
  useEventListener('visibilitychange', setVisibility, {
    depends: [visibility]
  });
  return visibility;
}
export default usePageVisibility;