import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";

/* eslint-disable no-param-reassign */
import { useState, useEffect } from 'react';
import { inBrowser } from '../utils';
var overflowScrollReg = /scroll|auto/i;
var defaultRoot = inBrowser ? window : undefined;

function isElement(node) {
  var ELEMENT_NODE_TYPE = 1;
  return node.tagName !== 'HTML' && node.tagName !== 'BODY' && node.nodeType === ELEMENT_NODE_TYPE;
}

export function getScrollParent(el) {
  var root = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultRoot;

  if (root === undefined) {
    root = window;
  }

  var node = el;

  while (node && node !== root && isElement(node)) {
    var _window$getComputedSt = window.getComputedStyle(node),
        overflowY = _window$getComputedSt.overflowY;

    if (overflowScrollReg.test(overflowY)) {
      if (node.tagName !== 'BODY') {
        return node;
      }

      var htmlOverflowY = window.getComputedStyle(node.parentNode).overflowY;

      if (overflowScrollReg.test(htmlOverflowY)) {
        return node;
      }
    }

    node = node.parentNode;
  }

  return root;
}

function useScrollParent(el) {
  var _useState = useState(),
      _useState2 = _slicedToArray(_useState, 2),
      scrollParent = _useState2[0],
      setScrollParent = _useState2[1];

  useEffect(function () {
    if (el) {
      setScrollParent(getScrollParent(el.current));
    }
  }, []);
  return scrollParent;
}

export default useScrollParent;