import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
var _excluded = ["open", "toggle", "clear"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import { createElement, useRef, useEffect } from 'react';
import ReactDOM from 'react-dom';
export function mountComponent(RootComponent, callback) {
  var root = document.createElement('div');

  var Container = function Container() {
    var ref = useRef(null);
    useEffect(function () {
      var _ref$current = ref.current,
          open = _ref$current.open,
          toggle = _ref$current.toggle,
          clear = _ref$current.clear,
          rest = _objectWithoutProperties(_ref$current, _excluded);

      callback(_objectSpread({
        open: open,
        toggle: toggle,
        clear: clear,
        unmount: function unmount() {
          ReactDOM.unmountComponentAtNode(root);

          if (root.parentNode) {
            root.parentNode.removeChild(root);
          }
        }
      }, rest));
    }, [ref.current]);
    return /*#__PURE__*/createElement(RootComponent, {
      ref: ref
    });
  };

  var app = /*#__PURE__*/createElement(Container);
  document.body.appendChild(root);
  ReactDOM.render(app, root);
}