"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _useMergedState3 = _interopRequireDefault(require("../hooks/use-merged-state"));

var _CheckboxContext = _interopRequireDefault(require("./CheckboxContext"));

var _useRefs3 = _interopRequireDefault(require("../hooks/use-refs"));

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var CheckBoxGroup = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('checkbox-group', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var _useRefs = (0, _useRefs3.default)(),
      _useRefs2 = (0, _slicedToArray2().default)(_useRefs, 2),
      childrenRefs = _useRefs2[0],
      setChildrenRefs = _useRefs2[1];

  var _useMergedState = (0, _useMergedState3.default)({
    value: props.value,
    defaultValue: props.defaultValue
  }),
      _useMergedState2 = (0, _slicedToArray2().default)(_useMergedState, 2),
      checked = _useMergedState2[0],
      setChecked = _useMergedState2[1];

  var toggleAll = function toggleAll() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (typeof options === 'boolean') {
      options = {
        checked: options
      };
    }

    var _options = options,
        isChecked = _options.checked,
        skipDisabled = _options.skipDisabled;
    var checkedChildren = childrenRefs.filter(function (item) {
      if (!item.props.bindGroup) {
        return false;
      }

      if (item.props.disabled && skipDisabled) {
        return item.checked;
      }

      return isChecked !== null && isChecked !== void 0 ? isChecked : !item.checked;
    });
    var names = checkedChildren.map(function (item) {
      return item.props.name;
    });
    setChecked(names);
    props.onChange(names);
  };

  var toggle = function toggle(name) {
    var _props$onChange;

    setChecked(name);
    (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, name);
  };

  (0, _react().useImperativeHandle)(ref, function () {
    return {
      toggleAll: toggleAll
    };
  });
  return /*#__PURE__*/_react().default.createElement(_CheckboxContext.default.Provider, {
    value: {
      parent: {
        props: props
      },
      toggle: toggle,
      checked: checked
    }
  }, /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem([props.direction]))
  }, _react().default.Children.toArray(props.children).filter(Boolean).map(function (child, index) {
    if (child.type.displayName !== 'Checkbox') return child;
    return /*#__PURE__*/_react().default.cloneElement(child, {
      ref: setChildrenRefs(index)
    });
  })));
});
var _default = CheckBoxGroup;
exports.default = _default;