"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

  _extends2 = function _extends2() {
    return data;
  };

  return data;
}

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _objectWithoutProperties2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

  _objectWithoutProperties2 = function _objectWithoutProperties2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames2() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames2 = function _classnames2() {
    return data;
  };

  return data;
}

var _icon = _interopRequireDefault(require("../icon"));

var _popup = _interopRequireDefault(require("../popup"));

var _button = _interopRequireDefault(require("../button"));

var _actionBar = _interopRequireDefault(require("../action-bar"));

var _utils = require("../utils");

var _constant = require("../utils/constant");

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

var _excluded = ["width", "title", "theme", "visible", "message", "className", "messageAlign", "closeIcon", "closeable", "closeOnClickOverlay", "onClickCloseIcon"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Dialog = function Dialog(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('dialog', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var width = props.width,
      title = props.title,
      theme = props.theme,
      visible = props.visible,
      message = props.message,
      className = props.className,
      messageAlign = props.messageAlign,
      closeIcon = props.closeIcon,
      closeable = props.closeable,
      closeOnClickOverlay = props.closeOnClickOverlay,
      onClickCloseIcon = props.onClickCloseIcon,
      others = (0, _objectWithoutProperties2().default)(props, _excluded);

  var renderTitle = function renderTitle() {
    if (props.title) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames2().default)(bem('header', {
          isolated: !props.message && !props.children
        }))
      }, title);
    }

    return null;
  };

  var renderContent = function renderContent() {
    if (props.children) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames2().default)(bem('content'))
      }, props.children);
    }

    if (message) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames2().default)(bem('content', {
          isolated: !title
        }))
      }, /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames2().default)(bem('message', (0, _defineProperty2().default)({
          'has-title': title
        }, messageAlign, messageAlign)))
      }, message));
    }

    return null;
  };

  var renderButtons = function renderButtons() {
    var _props$cancelProps, _props$cancelProps2, _props$cancelProps3, _props$confirmProps, _props$confirmProps2, _props$confirmProps3;

    return /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames2().default)(_constant.BORDER_TOP, bem('footer'))
    }, props.showCancelButton && /*#__PURE__*/_react().default.createElement(_button.default, {
      size: "large",
      text: props.cancelButtonText || '取消',
      className: (0, _classnames2().default)(bem('cancel')),
      style: {
        color: props.cancelButtonColor
      },
      loading: (_props$cancelProps = props.cancelProps) === null || _props$cancelProps === void 0 ? void 0 : _props$cancelProps.loading,
      disabled: (_props$cancelProps2 = props.cancelProps) === null || _props$cancelProps2 === void 0 ? void 0 : _props$cancelProps2.disabled,
      onClick: (_props$cancelProps3 = props.cancelProps) !== null && _props$cancelProps3 !== void 0 && _props$cancelProps3.loading ? _utils.noop : props.onCancel
    }), props.showConfirmButton && /*#__PURE__*/_react().default.createElement(_button.default, {
      size: "large",
      text: props.confirmButtonText || '确认',
      className: (0, _classnames2().default)(bem('confirm'), (0, _defineProperty2().default)({}, _constant.BORDER_LEFT, props.showCancelButton)),
      round: theme === 'round-button',
      style: {
        color: props.confirmButtonColor
      },
      loading: (_props$confirmProps = props.confirmProps) === null || _props$confirmProps === void 0 ? void 0 : _props$confirmProps.loading,
      disabled: (_props$confirmProps2 = props.confirmProps) === null || _props$confirmProps2 === void 0 ? void 0 : _props$confirmProps2.disabled,
      onClick: (_props$confirmProps3 = props.confirmProps) !== null && _props$confirmProps3 !== void 0 && _props$confirmProps3.loading ? _utils.noop : props.onConfirm
    }));
  };

  var renderRoundButtons = function renderRoundButtons() {
    var _props$cancelProps4, _props$cancelProps5, _props$cancelProps6, _props$confirmProps4, _props$confirmProps5, _props$confirmProps6;

    return /*#__PURE__*/_react().default.createElement(_actionBar.default, {
      className: (0, _classnames2().default)(bem('footer'))
    }, props.showCancelButton && /*#__PURE__*/_react().default.createElement(_actionBar.default.Button, {
      type: "warning",
      text: props.cancelButtonText || '取消',
      className: (0, _classnames2().default)(bem('cancel')),
      color: props.cancelButtonColor,
      loading: (_props$cancelProps4 = props.cancelProps) === null || _props$cancelProps4 === void 0 ? void 0 : _props$cancelProps4.loading,
      disabled: (_props$cancelProps5 = props.cancelProps) === null || _props$cancelProps5 === void 0 ? void 0 : _props$cancelProps5.disabled,
      onClick: (_props$cancelProps6 = props.cancelProps) !== null && _props$cancelProps6 !== void 0 && _props$cancelProps6.loading ? _utils.noop : props.onCancel
    }), props.showConfirmButton && /*#__PURE__*/_react().default.createElement(_actionBar.default.Button, {
      type: "danger",
      text: props.confirmButtonText || '确认',
      className: (0, _classnames2().default)(bem('confirm')),
      color: props.confirmButtonColor,
      loading: (_props$confirmProps4 = props.confirmProps) === null || _props$confirmProps4 === void 0 ? void 0 : _props$confirmProps4.loading,
      disabled: (_props$confirmProps5 = props.confirmProps) === null || _props$confirmProps5 === void 0 ? void 0 : _props$confirmProps5.disabled,
      onClick: (_props$confirmProps6 = props.confirmProps) !== null && _props$confirmProps6 !== void 0 && _props$confirmProps6.loading ? _utils.noop : props.onConfirm
    }));
  };

  var renderCloseIcon = function renderCloseIcon() {
    if (!closeable) return null;

    if (typeof props.closeIcon === 'string') {
      return /*#__PURE__*/_react().default.createElement(_icon.default, {
        name: props.closeIcon,
        className: (0, _classnames2().default)(bem('close-icon')),
        onClick: function onClick() {
          var _props$onClose;

          if (onClickCloseIcon) {
            onClickCloseIcon();
          }

          (_props$onClose = props.onClose) === null || _props$onClose === void 0 ? void 0 : _props$onClose.call(props);
        }
      });
    }

    if ( /*#__PURE__*/(0, _react().isValidElement)(props.closeIcon)) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames2().default)(bem('close-icon')),
        onClick: function onClick() {
          var _props$onClose2;

          if (onClickCloseIcon) {
            onClickCloseIcon();
          }

          (_props$onClose2 = props.onClose) === null || _props$onClose2 === void 0 ? void 0 : _props$onClose2.call(props);
        }
      }, props.closeIcon);
    }

    return null;
  };

  var renderFooter = function renderFooter() {
    if (props.footer) return props.footer;
    return props.theme === 'round-button' ? renderRoundButtons() : renderButtons();
  };

  return /*#__PURE__*/_react().default.createElement(_popup.default, (0, _extends2().default)({}, others, {
    visible: visible,
    className: (0, _classnames2().default)(bem([theme]), className),
    style: {
      width: (0, _utils.addUnit)(width)
    },
    "aria-labelledby": title || message,
    closeOnClickOverlay: closeOnClickOverlay,
    onClose: props.onClose,
    onClosed: props.onClosed
  }), renderCloseIcon(), renderTitle(), renderContent(), renderFooter());
};

Dialog.defaultProps = {
  closeIcon: 'cross',
  transition: 'rc-dialog-bounce',
  showConfirmButton: true,
  closeOnPopstate: true
};
var _default = Dialog;
exports.default = _default;