"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

  _extends2 = function _extends2() {
    return data;
  };

  return data;
}

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _objectWithoutProperties2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

  _objectWithoutProperties2 = function _objectWithoutProperties2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _reactDom() {
  var data = _interopRequireDefault(require("react-dom"));

  _reactDom = function _reactDom() {
    return data;
  };

  return data;
}

var _utils = require("../utils");

var _Dialog = _interopRequireDefault(require("./Dialog"));

var _getContainer = require("../utils/dom/getContainer");

var _excluded = ["onClosed", "onCancel", "onConfirm", "onClose", "cancelProps", "confirmProps"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Dialog = _Dialog.default; // 可返回用于销毁此弹窗的方法

Dialog.show = function (props) {
  var defaultOptions = {
    overlay: true,
    closeable: false,
    closeIcon: 'cross',
    lockScroll: true,
    transition: 'rc-dialog-bounce',
    showConfirmButton: true,
    showCancelButton: false,
    closeOnClickOverlay: false
  };
  var onClosed = props.onClosed,
      _props$onCancel = props.onCancel,
      onCancel = _props$onCancel === void 0 ? _utils.noop : _props$onCancel,
      _props$onConfirm = props.onConfirm,
      onConfirm = _props$onConfirm === void 0 ? _utils.noop : _props$onConfirm,
      _props$onClose = props.onClose,
      onClose = _props$onClose === void 0 ? _utils.noop : _props$onClose,
      cancelProps = props.cancelProps,
      confirmProps = props.confirmProps,
      restProps = (0, _objectWithoutProperties2().default)(props, _excluded);
  var userContainer = (0, _getContainer.resolveContainer)(props.teleport);
  var container = document.createElement('div');
  userContainer.appendChild(container);
  var destroy = _utils.noop;

  var TempDialog = function TempDialog() {
    var _useState = (0, _react().useState)(false),
        _useState2 = (0, _slicedToArray2().default)(_useState, 2),
        visible = _useState2[0],
        setVisible = _useState2[1];

    var _useState3 = (0, _react().useState)(false),
        _useState4 = (0, _slicedToArray2().default)(_useState3, 2),
        cancelLoading = _useState4[0],
        setCancelLoading = _useState4[1];

    var _useState5 = (0, _react().useState)(false),
        _useState6 = (0, _slicedToArray2().default)(_useState5, 2),
        okLoading = _useState6[0],
        setOkLoading = _useState6[1];

    (0, _react().useEffect)(function () {
      setVisible(true);
    }, []);

    destroy = function destroy() {
      setVisible(false);
      if (onClose) onClose();
    };

    var _afterClose = function _afterClose() {
      if (onClosed) {
        onClosed();
      }

      var unmountResult = _reactDom().default.unmountComponentAtNode(container);

      if (unmountResult && container.parentNode) {
        container.parentNode.removeChild(container);
      }
    };

    var _onConfirm = /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee(e) {
        var i;
        return _regenerator().default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                i = setTimeout(function () {
                  return setOkLoading(true);
                });
                _context.next = 3;
                return onConfirm(e);

              case 3:
                _context.t0 = _context.sent;

                if (!(_context.t0 !== false)) {
                  _context.next = 9;
                  break;
                }

                clearTimeout(i);
                destroy();
                _context.next = 11;
                break;

              case 9:
                clearTimeout(i);
                setOkLoading(false);

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function _onConfirm(_x) {
        return _ref.apply(this, arguments);
      };
    }();

    var _onCancel = /*#__PURE__*/function () {
      var _ref2 = (0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee2(e, clickOverlay) {
        var i;
        return _regenerator().default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!clickOverlay) {
                  _context2.next = 3;
                  break;
                }

                destroy();
                return _context2.abrupt("return");

              case 3:
                i = setTimeout(function () {
                  return setCancelLoading(true);
                });
                _context2.next = 6;
                return onCancel(e);

              case 6:
                _context2.t0 = _context2.sent;

                if (!(_context2.t0 !== false)) {
                  _context2.next = 12;
                  break;
                }

                clearTimeout(i);
                destroy();
                _context2.next = 14;
                break;

              case 12:
                clearTimeout(i);
                setCancelLoading(false);

              case 14:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function _onCancel(_x2, _x3) {
        return _ref2.apply(this, arguments);
      };
    }();

    return /*#__PURE__*/_react().default.createElement(_Dialog.default, (0, _extends2().default)({}, defaultOptions, restProps, {
      visible: visible,
      teleport: function teleport() {
        return container;
      },
      cancelProps: _objectSpread({
        loading: cancelLoading
      }, cancelProps),
      confirmProps: _objectSpread({
        loading: okLoading
      }, confirmProps),
      onClose: destroy,
      onCancel: _onCancel,
      onConfirm: _onConfirm,
      onClosed: _afterClose
    }));
  };

  _reactDom().default.render( /*#__PURE__*/_react().default.createElement(TempDialog, null), container);

  return destroy;
}; // 可使用 async/await 的方式


Dialog.alert = function (props) {
  var _props$onConfirm2 = props.onConfirm,
      _onConfirm2 = _props$onConfirm2 === void 0 ? _utils.noop : _props$onConfirm2;

  return new Promise(function (resolve) {
    Dialog.show(_objectSpread(_objectSpread({}, props), {}, {
      onConfirm: function onConfirm(e) {
        _onConfirm2(e);

        resolve(e);
      }
    }));
  });
};

Dialog.confirm = function (props) {
  var _props$onCancel2 = props.onCancel,
      _onCancel2 = _props$onCancel2 === void 0 ? _utils.noop : _props$onCancel2,
      _props$onConfirm3 = props.onConfirm,
      _onConfirm3 = _props$onConfirm3 === void 0 ? _utils.noop : _props$onConfirm3;

  return new Promise(function (resolve, reject) {
    Dialog.show(_objectSpread(_objectSpread({
      // 强制显示 OK Btn
      confirmButtonText: '确认',
      showCancelButton: true
    }, props), {}, {
      onCancel: function onCancel(e) {
        _onCancel2(e);

        reject();
      },
      onConfirm: function onConfirm(e) {
        _onConfirm3(e);

        resolve(true);
      }
    }));
  });
};

var _default = Dialog;
exports.default = _default;