"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

  _extends2 = function _extends2() {
    return data;
  };

  return data;
}

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _objectWithoutProperties2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

  _objectWithoutProperties2 = function _objectWithoutProperties2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _FlexContext = _interopRequireDefault(require("./FlexContext"));

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

var _excluded = ["direction", "wrap", "justify", "align", "gutter", "style", "className", "children"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Flex = function Flex(props) {
  var direction = props.direction,
      wrap = props.wrap,
      justify = props.justify,
      align = props.align,
      gutter = props.gutter,
      style = props.style,
      className = props.className,
      children = props.children,
      rest = (0, _objectWithoutProperties2().default)(props, _excluded);

  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('flexbox', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var getGutter = (0, _react().useMemo)(function () {
    return Array.isArray(gutter) ? gutter : [gutter, 0];
  }, [gutter]);

  var rowStyle = _objectSpread(_objectSpread(_objectSpread({}, getGutter[0] > 0 ? {
    marginLeft: getGutter[0] / -2,
    marginRight: getGutter[0] / -2
  } : {}), getGutter[1] > 0 ? {
    marginTop: getGutter[1] / -2,
    marginBottom: getGutter[1] / 2
  } : {}), style);

  var wrapCls = (0, _classnames().default)(className, bem([direction, wrap, justify ? "justify-".concat(justify) : false, align ? "align-".concat(align) : false]));
  return /*#__PURE__*/_react().default.createElement(_FlexContext.default.Provider, {
    value: {
      gutter: getGutter
    }
  }, /*#__PURE__*/_react().default.createElement("div", (0, _extends2().default)({
    className: wrapCls,
    style: rowStyle
  }, rest), children));
};

Flex.defaultProps = {
  gutter: 0
};
var _default = Flex;
exports.default = _default;