"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _objectWithoutProperties2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

  _objectWithoutProperties2 = function _objectWithoutProperties2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _utils = require("../utils");

var _constant = require("../utils/constant");

var _badge = _interopRequireDefault(require("../badge"));

var _icon = _interopRequireDefault(require("../icon"));

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

var _excluded = ["children", "className", "style"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var GridItem = function GridItem(_ref) {
  var children = _ref.children,
      className = _ref.className,
      style = _ref.style,
      props = (0, _objectWithoutProperties2().default)(_ref, _excluded);

  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('grid-item', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var index = props.index,
      parent = props.parent;

  if (!parent) {
    if (process.env.NODE_ENV !== 'production') {
      // eslint-disable-next-line no-console
      console.error('[rc-ui-lib] <GridItem> must be a child component of <Grid>.');
    }
  }

  var rootStyle = (0, _react().useMemo)(function () {
    var square = parent.square,
        gutter = parent.gutter,
        columnNum = parent.columnNum;
    var percent = "".concat(100 / +columnNum, "%");

    var internalStyle = _objectSpread(_objectSpread({}, style), {}, {
      flexBasis: percent
    });

    if (square) {
      internalStyle.paddingTop = percent;
    } else if (gutter) {
      var gutterValue = (0, _utils.addUnit)(gutter);
      internalStyle.paddingRight = gutterValue;

      if (index >= columnNum) {
        internalStyle.marginTop = gutterValue;
      }
    }

    return internalStyle;
  }, [parent.style, parent.gutter, parent.columnNum]);
  var contentStyle = (0, _react().useMemo)(function () {
    var square = parent.square,
        gutter = parent.gutter;

    if (square && gutter) {
      var gutterValue = (0, _utils.addUnit)(gutter);
      return _objectSpread(_objectSpread({}, props.contentStyle), {}, {
        right: gutterValue,
        bottom: gutterValue,
        height: 'auto'
      });
    }

    return props.contentStyle;
  }, [parent.gutter, parent.columnNum, props.contentStyle]);

  var renderIcon = function renderIcon() {
    if (typeof props.icon === 'string') {
      return /*#__PURE__*/_react().default.createElement(_icon.default, {
        badge: props.badge,
        name: props.icon,
        size: parent.iconSize,
        className: (0, _classnames().default)(bem('icon')),
        classPrefix: props.iconPrefix,
        color: props.iconColor
      });
    }

    if ( /*#__PURE__*/_react().default.isValidElement(props.icon)) {
      return /*#__PURE__*/_react().default.createElement(_badge.default, props.badge, props.icon);
    }

    return null;
  };

  var renderText = function renderText() {
    if ( /*#__PURE__*/_react().default.isValidElement(props.text)) {
      return props.text;
    }

    if (props.text) {
      return /*#__PURE__*/_react().default.createElement("span", {
        className: (0, _classnames().default)(bem('text'))
      }, props.text);
    }

    return null;
  };

  var renderContent = function renderContent() {
    if (children) {
      return children;
    }

    return /*#__PURE__*/_react().default.createElement(_react().default.Fragment, null, renderIcon(), renderText());
  };

  var center = parent.center,
      border = parent.border,
      square = parent.square,
      gutter = parent.gutter,
      reverse = parent.reverse,
      direction = parent.direction;
  var classes = (0, _classnames().default)(props.contentClassName, bem('content', [direction, {
    center: center,
    square: square,
    reverse: reverse,
    clickable: !!props.onClick,
    surround: border && gutter
  }]), (0, _defineProperty2().default)({}, _constant.BORDER, border));
  return /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(className, bem({
      square: square
    })),
    style: rootStyle
  }, /*#__PURE__*/_react().default.createElement("div", {
    role: props.onClick ? 'button' : undefined,
    className: classes,
    style: contentStyle,
    onClick: props.onClick
  }, renderContent()));
};

GridItem.defaultProps = {
  index: 0,
  parent: {}
};
var _default = GridItem;
exports.default = _default;