"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
exports.getScrollParent = getScrollParent;

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = require("react");

  _react = function _react() {
    return data;
  };

  return data;
}

var _utils = require("../utils");

/* eslint-disable no-param-reassign */
var overflowScrollReg = /scroll|auto/i;
var defaultRoot = _utils.inBrowser ? window : undefined;

function isElement(node) {
  var ELEMENT_NODE_TYPE = 1;
  return node.tagName !== 'HTML' && node.tagName !== 'BODY' && node.nodeType === ELEMENT_NODE_TYPE;
}

function getScrollParent(el) {
  var root = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultRoot;

  if (root === undefined) {
    root = window;
  }

  var node = el;

  while (node && node !== root && isElement(node)) {
    var _window$getComputedSt = window.getComputedStyle(node),
        overflowY = _window$getComputedSt.overflowY;

    if (overflowScrollReg.test(overflowY)) {
      if (node.tagName !== 'BODY') {
        return node;
      }

      var htmlOverflowY = window.getComputedStyle(node.parentNode).overflowY;

      if (overflowScrollReg.test(htmlOverflowY)) {
        return node;
      }
    }

    node = node.parentNode;
  }

  return root;
}

function useScrollParent(el) {
  var _useState = (0, _react().useState)(),
      _useState2 = (0, _slicedToArray2().default)(_useState, 2),
      scrollParent = _useState2[0],
      setScrollParent = _useState2[1];

  (0, _react().useEffect)(function () {
    if (el) {
      setScrollParent(getScrollParent(el.current));
    }
  }, []);
  return scrollParent;
}

var _default = useScrollParent;
exports.default = _default;