"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createFromIconfontCN;

function _react() {
  var data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

var _Icon = _interopRequireDefault(require("./Icon"));

var cache = new Set();

function createFromIconfontCN(scriptUrl) {
  if (typeof document !== 'undefined' && typeof window !== 'undefined' && typeof document.createElement === 'function' && typeof scriptUrl === 'string' && scriptUrl.length && !cache.has(scriptUrl)) {
    var script = document.createElement('script');
    script.setAttribute('src', scriptUrl);
    script.setAttribute('data-namespace', scriptUrl);
    cache.add(scriptUrl);
    document.body.appendChild(script);
  }

  var Iconfont = function Iconfont(props) {
    Iconfont.displayName = 'Iconfont';
    var name = props.name;
    var content;

    if (name) {
      content = /*#__PURE__*/_react().default.createElement("svg", {
        width: "1em",
        height: "1em",
        fill: "currentColor"
      }, /*#__PURE__*/_react().default.createElement("use", {
        xlinkHref: "#".concat(name)
      }));
    }

    return /*#__PURE__*/_react().default.createElement(_Icon.default, props, content);
  };

  return Iconfont;
}