"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

  _extends2 = function _extends2() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _objectWithoutProperties2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

  _objectWithoutProperties2 = function _objectWithoutProperties2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _reactDom() {
  var data = _interopRequireDefault(require("react-dom"));

  _reactDom = function _reactDom() {
    return data;
  };

  return data;
}

var _utils = require("../utils");

var _ImagePreview = _interopRequireDefault(require("./ImagePreview"));

var _getContainer = require("../utils/dom/getContainer");

var _excluded = ["onClose", "beforeClose"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var ImagePreview = _ImagePreview.default;
var defaultConfig = {
  loop: true,
  images: [],
  className: '',
  showIndex: true,
  closeable: false,
  closeIcon: 'clear',
  startPosition: 0,
  swipeDuration: 300,
  closeOnPopstate: true,
  closeIconPosition: 'top-right'
}; // 可返回用于销毁此弹窗的方法

ImagePreview.open = function (props) {
  var _props$onClose = props.onClose,
      onClose = _props$onClose === void 0 ? _utils.noop : _props$onClose,
      beforeClose = props.beforeClose,
      restProps = (0, _objectWithoutProperties2().default)(props, _excluded);
  var userContainer = (0, _getContainer.resolveContainer)(props.teleport);
  var container = document.createElement('div');
  userContainer.appendChild(container);
  var destroy = _utils.noop;

  var TempDialog = function TempDialog() {
    var _useState = (0, _react().useState)(false),
        _useState2 = (0, _slicedToArray2().default)(_useState, 2),
        visible = _useState2[0],
        setVisible = _useState2[1];

    (0, _react().useEffect)(function () {
      setVisible(true);
    }, []);

    destroy = function destroy(p) {
      setVisible(false);
      if (onClose) onClose(p);
    };

    var _afterClose = /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee(p) {
        var unmountResult;
        return _regenerator().default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return beforeClose === null || beforeClose === void 0 ? void 0 : beforeClose(0);

              case 2:
                _context.t0 = _context.sent;

                if (!(_context.t0 !== false)) {
                  _context.next = 8;
                  break;
                }

                destroy(p);
                unmountResult = _reactDom().default.unmountComponentAtNode(container);

                if (unmountResult && container.parentNode) {
                  container.parentNode.removeChild(container);
                }

                return _context.abrupt("return", true);

              case 8:
                return _context.abrupt("return", false);

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function _afterClose(_x) {
        return _ref.apply(this, arguments);
      };
    }();

    return /*#__PURE__*/_react().default.createElement(_ImagePreview.default, (0, _extends2().default)({}, defaultConfig, restProps, {
      visible: visible,
      teleport: function teleport() {
        return container;
      },
      onClose: destroy,
      beforeClose: _afterClose
    }));
  };

  _reactDom().default.render( /*#__PURE__*/_react().default.createElement(TempDialog, null), container);

  return destroy;
};

var _default = ImagePreview;
exports.default = _default;