"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

  _extends2 = function _extends2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _utils = require("../utils");

var _icon = _interopRequireDefault(require("../icon"));

var _hooks = require("../hooks");

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Image = function Image(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('image', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var fit = props.fit,
      errorIcon = props.errorIcon,
      loadingIcon = props.loadingIcon,
      showError = props.showError,
      showLoading = props.showLoading,
      block = props.block;

  var _useSetState = (0, _hooks.useSetState)({
    loading: true,
    error: false
  }),
      _useSetState2 = (0, _slicedToArray2().default)(_useSetState, 2),
      status = _useSetState2[0],
      setStatus = _useSetState2[1];

  var imgRef = (0, _react().useRef)(null);
  var unmountedRef = (0, _react().useRef)(false);
  var style = (0, _react().useMemo)(function () {
    var internalStyle = {};

    if ((0, _utils.isDef)(props.width)) {
      internalStyle.width = (0, _utils.addUnit)(props.width);
    }

    if ((0, _utils.isDef)(props.height)) {
      internalStyle.height = (0, _utils.addUnit)(props.height);
    }

    if ((0, _utils.isDef)(props.radius)) {
      internalStyle.overflow = 'hidden';
      internalStyle.borderRadius = (0, _utils.addUnit)(props.radius);
    }

    return internalStyle;
  }, []);
  (0, _react().useEffect)(function () {
    if (imgRef.current && imgRef.current.complete) {
      setStatus({
        loading: false,
        error: false
      });
    }

    return function () {
      unmountedRef.current = true;
    };
  }, []);
  (0, _hooks.useUpdateEffect)(function () {
    if (imgRef.current && !imgRef.current.complete) {
      setStatus({
        error: false,
        loading: true
      });
    }
  }, [props.src]);

  var onLoad = function onLoad(e) {
    if (!unmountedRef.current) {
      var _props$onLoad;

      setStatus({
        loading: false
      });
      (_props$onLoad = props.onLoad) === null || _props$onLoad === void 0 ? void 0 : _props$onLoad.call(props, e);
    }
  };

  var onError = function onError(e) {
    if (!unmountedRef.current) {
      var _props$onLoad2;

      setStatus({
        error: true,
        loading: false
      });
      (_props$onLoad2 = props.onLoad) === null || _props$onLoad2 === void 0 ? void 0 : _props$onLoad2.call(props, e);
    }
  };

  var renderLoadingIcon = function renderLoadingIcon() {
    if (typeof loadingIcon !== 'string') return loadingIcon;
    return /*#__PURE__*/_react().default.createElement(_icon.default, {
      size: props.iconSize,
      name: loadingIcon,
      className: (0, _classnames().default)(bem('loading-icon')),
      classPrefix: props.iconPrefix
    });
  };

  var renderErrorIcon = function renderErrorIcon() {
    if (typeof errorIcon !== 'string') return errorIcon;
    return /*#__PURE__*/_react().default.createElement(_icon.default, {
      size: props.iconSize,
      name: errorIcon,
      className: (0, _classnames().default)(bem('error-icon')),
      classPrefix: props.iconPrefix
    });
  };

  var renderPlaceholder = function renderPlaceholder() {
    if (status.loading && showLoading) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('loading')),
        onClick: props.onClick
      }, renderLoadingIcon());
    }

    if (status.error && showError) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('error')),
        onClick: props.onClick
      }, renderErrorIcon());
    }

    return null;
  };

  var renderImage = function renderImage() {
    if (status.error || !props.src) {
      return null;
    }

    var attrs = {
      className: (0, _classnames().default)(bem('img')),
      style: {
        objectFit: fit
      }
    };
    return /*#__PURE__*/_react().default.createElement("img", (0, _extends2().default)({
      ref: imgRef,
      alt: props.alt || 'img',
      src: props.src,
      onLoad: onLoad,
      onError: onError
    }, attrs));
  };

  return /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(props.className, bem({
      block: block,
      round: props.round
    })),
    style: style,
    onClick: props.onClick
  }, renderImage(), renderPlaceholder(), props.children);
};

Image.defaultProps = {
  fit: 'fill',
  errorIcon: 'photo-fail',
  loadingIcon: 'photo',
  showError: true,
  showLoading: true,
  block: true
};
var _default = Image;
exports.default = _default;