"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _utils = require("../utils");

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var SpinIcon = function SpinIcon(_ref) {
  var bem = _ref.bem;
  return /*#__PURE__*/_react().default.createElement(_react().default.Fragment, null, Array(12).fill(null) // eslint-disable-next-line react/no-array-index-key
  .map(function (_, index) {
    return /*#__PURE__*/_react().default.createElement("i", {
      key: index,
      className: (0, _classnames().default)(bem('line', String(index + 1)))
    });
  }));
};

var CircularIcon = function CircularIcon(_ref2) {
  var bem = _ref2.bem;
  return /*#__PURE__*/_react().default.createElement("svg", {
    className: (0, _classnames().default)(bem('circular')),
    viewBox: "25 25 50 50"
  }, /*#__PURE__*/_react().default.createElement("circle", {
    cx: "50",
    cy: "50",
    r: "20",
    fill: "none"
  }));
};

var BallIcon = function BallIcon(_ref3) {
  var bem = _ref3.bem;
  return /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('ball'))
  }, /*#__PURE__*/_react().default.createElement("div", null), /*#__PURE__*/_react().default.createElement("div", null), /*#__PURE__*/_react().default.createElement("div", null));
};

var Icon = function Icon(bem) {
  return {
    spinner: /*#__PURE__*/_react().default.createElement(SpinIcon, {
      bem: bem
    }),
    circular: /*#__PURE__*/_react().default.createElement(CircularIcon, {
      bem: bem
    }),
    ball: /*#__PURE__*/_react().default.createElement(BallIcon, {
      bem: bem
    })
  };
};

var Loading = function Loading(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('loading', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var className = props.className,
      type = props.type,
      vertical = props.vertical,
      color = props.color,
      size = props.size,
      textColor = props.textColor,
      children = props.children,
      textSize = props.textSize;
  var spinnerStyle = (0, _react().useMemo)(function () {
    return _objectSpread({
      color: color
    }, (0, _utils.getSizeStyle)(size));
  }, [color, size]);

  var renderText = function renderText() {
    if (children) {
      return /*#__PURE__*/_react().default.createElement("span", {
        className: (0, _classnames().default)(bem('text')),
        style: {
          fontSize: (0, _utils.addUnit)(textSize),
          color: textColor !== null && textColor !== void 0 ? textColor : color
        }
      }, children);
    }

    return null;
  };

  return /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(className, bem([type, {
      vertical: vertical
    }]))
  }, /*#__PURE__*/_react().default.createElement("span", {
    className: (0, _classnames().default)(bem('spinner', type)),
    style: spinnerStyle
  }, Icon(bem)[type]), renderText());
};

Loading.defaultProps = {
  type: 'circular'
};
var _default = Loading;
exports.default = _default;