"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _icon = _interopRequireDefault(require("../icon"));

var _useRect = require("../hooks/use-rect");

var _useEventListener = _interopRequireDefault(require("../hooks/use-event-listener"));

var _utils = require("../utils");

var _raf = require("../utils/raf");

var _hooks = require("../hooks");

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

var _PopupContext = _interopRequireDefault(require("../popup/PopupContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var NoticeBar = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var text = props.text,
      color = props.color,
      background = props.background,
      wrapable = props.wrapable,
      scrollable = props.scrollable,
      speed = props.speed,
      _props$delay = props.delay,
      delay = _props$delay === void 0 ? 1 : _props$delay;

  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var popupContext = (0, _react().useContext)(_PopupContext.default);

  var _createNamespace = createNamespace('notice-bar', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var _useSetState = (0, _hooks.useSetState)({
    show: true,
    offset: 0,
    duration: 0
  }),
      _useSetState2 = (0, _slicedToArray2().default)(_useSetState, 2),
      state = _useSetState2[0],
      setState = _useSetState2[1];

  var wrapRef = (0, _react().useRef)();
  var contentRef = (0, _react().useRef)();
  var wrapWidth = (0, _react().useRef)(0);
  var contentWidth = (0, _react().useRef)(0);
  var startTimer = (0, _react().useRef)(null);

  var renderLeftIcon = function renderLeftIcon() {
    if (typeof props.leftIcon !== 'string' && /*#__PURE__*/_react().default.isValidElement(props.leftIcon)) {
      return props.leftIcon;
    }

    if (props.leftIcon) {
      return /*#__PURE__*/_react().default.createElement(_icon.default, {
        className: (0, _classnames().default)(bem('left-icon')),
        name: props.leftIcon
      });
    }

    return null;
  };

  var getRightIconName = function getRightIconName() {
    if (props.mode === 'closeable') {
      return 'cross';
    }

    if (props.mode === 'link') {
      return 'arrow';
    }

    return '';
  };

  var onClickRightIcon = function onClickRightIcon(event) {
    if (props.mode === 'closeable') {
      setState({
        show: false
      });

      if (props.onClose) {
        props.onClose(event);
      }
    }
  }; //  右侧图标


  var renderRightIcon = function renderRightIcon() {
    if (props.rightIcon) {
      return props.rightIcon;
    }

    var name = getRightIconName();

    if (name) {
      return /*#__PURE__*/_react().default.createElement(_icon.default, {
        name: name,
        className: (0, _classnames().default)(bem('right-icon')),
        onClick: onClickRightIcon
      });
    }

    return null;
  }; //  动画结束


  var onTransitionEnd = function onTransitionEnd() {
    setState({
      offset: wrapWidth.current,
      duration: 0
    });
    (0, _raf.raf)(function () {
      // use double raf to ensure animation can start
      (0, _raf.doubleRaf)(function () {
        setState({
          offset: -contentWidth.current,
          duration: (contentWidth.current + wrapWidth.current) / speed
        });

        if (props.onReplay) {
          props.onReplay();
        }
      });
    });
  }; //  文字部分


  var renderMarquee = function renderMarquee() {
    var ellipsis = scrollable === false && !props.wrapable;
    var style = {
      transform: state.offset ? "translateX(".concat(state.offset, "px)") : '',
      transitionDuration: "".concat(state.duration, "s")
    };
    return /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(bem('wrap')),
      ref: wrapRef
    }, /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(bem('content'), {
        'rc-ellipsis': ellipsis
      }),
      ref: contentRef,
      style: style,
      onTransitionEnd: onTransitionEnd
    }, props.children || text));
  };

  var reset = function reset() {
    var ms = (0, _utils.isDef)(delay) ? +delay * 1000 : 0;
    wrapWidth.current = 0;
    contentWidth.current = 0;
    setState({
      offset: 0,
      duration: 0
    });
    clearTimeout(startTimer.current);
    startTimer.current = setTimeout(function () {
      if (!wrapRef.current || !contentRef.current || scrollable === false) {
        return;
      }

      var wrapRefWidth = (0, _useRect.getRect)(wrapRef.current).width;
      var contentRefWidth = (0, _useRect.getRect)(contentRef.current).width;

      if (scrollable || contentRefWidth > wrapRefWidth) {
        (0, _raf.doubleRaf)(function () {
          wrapWidth.current = wrapRefWidth;
          contentWidth.current = contentRefWidth;
          setState({
            offset: -contentWidth.current,
            duration: contentWidth.current / speed
          });
        });
      }
    }, ms);
  }; // fix cache issues with forwards and back history in safari
  // see: https://guwii.com/cache-issues-with-forwards-and-back-history-in-safari/


  (0, _useEventListener.default)('pageshow', reset);
  (0, _react().useEffect)(function () {
    reset();
  }, [text, scrollable]);
  (0, _hooks.useUpdateEffect)(function () {
    reset();
  }, [popupContext.visible]);
  (0, _react().useImperativeHandle)(ref, function () {
    return {
      reset: reset
    };
  });
  return state.show && /*#__PURE__*/_react().default.createElement("div", {
    role: "alert",
    className: (0, _classnames().default)(bem({
      wrapable: wrapable
    }), props.className),
    style: _objectSpread({
      color: color,
      background: background
    }, props.style),
    onClick: props.onClick
  }, renderLeftIcon(), renderMarquee(), renderRightIcon());
});
NoticeBar.defaultProps = {
  delay: 1,
  speed: 60,
  onClick: _utils.noop,
  onClose: _utils.noop
};
var _default = NoticeBar;
exports.default = _default;