"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sharedPopupProps = exports.default = void 0;

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

function _reactTransitionGroup() {
  var data = require("react-transition-group");

  _reactTransitionGroup = function _reactTransitionGroup() {
    return data;
  };

  return data;
}

var _icon = _interopRequireDefault(require("../icon"));

var _overlay = _interopRequireDefault(require("../overlay"));

var _useLockScroll3 = _interopRequireDefault(require("../hooks/use-lock-scroll"));

var _useEventListener = _interopRequireDefault(require("../hooks/use-event-listener"));

var _utils = require("../utils");

var _interceptor = require("../utils/interceptor");

var _renderToContainer = require("../utils/dom/renderToContainer");

var _useSsrCompat3 = _interopRequireDefault(require("../hooks/use-ssr-compat"));

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

var _PopupContext = _interopRequireDefault(require("./PopupContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var sharedPopupProps = ['round', 'zIndex', 'closeable', 'overlay', 'overlayClass', 'overlayStyle', 'destroyOnClose', 'forceRender', 'lockScroll', 'duration', 'transition', 'closeOnClickOverlay', 'closeOnPopstate', 'onClickOverlay', 'safeAreaInsetBottom', 'onOpen', 'onClose', 'onOpened', 'onClosed', 'beforeClose'];
exports.sharedPopupProps = sharedPopupProps;
var globalZIndex = 2000;
var Popup = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('popup', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var round = props.round,
      visible = props.visible,
      closeable = props.closeable,
      title = props.title,
      descrition = props.descrition,
      children = props.children,
      duration = props.duration,
      closeIcon = props.closeIcon,
      position = props.position;
  var opened = (0, _react().useRef)(false);
  var zIndex = (0, _react().useRef)(globalZIndex);
  var popupRef = (0, _react().useRef)();

  var _useState = (0, _react().useState)(visible),
      _useState2 = (0, _slicedToArray2().default)(_useState, 2),
      animatedVisible = _useState2[0],
      setAnimatedVisible = _useState2[1];

  var _useLockScroll = (0, _useLockScroll3.default)(function () {
    return props.lockScroll;
  }),
      _useLockScroll2 = (0, _slicedToArray2().default)(_useLockScroll, 2),
      lockScroll = _useLockScroll2[0],
      unlockScroll = _useLockScroll2[1];

  var _useSsrCompat = (0, _useSsrCompat3.default)(),
      _useSsrCompat2 = (0, _slicedToArray2().default)(_useSsrCompat, 2),
      ssrCompatRender = _useSsrCompat2[0],
      rendered = _useSsrCompat2[1];

  var style = (0, _react().useMemo)(function () {
    var initStyle = _objectSpread({
      zIndex: zIndex.current
    }, props.style);

    if ((0, _utils.isDef)(props.duration)) {
      var key = props.position === 'center' ? 'animationDuration' : 'transitionDuration';
      initStyle[key] = "".concat(props.duration, "ms");
    }

    return initStyle;
  }, [zIndex.current, props.style, props.duration]);

  var open = function open() {
    var _props$onOpen;

    if (props.zIndex !== undefined) {
      globalZIndex = +props.zIndex;
    }

    opened.current = true;
    zIndex.current = ++globalZIndex;
    (_props$onOpen = props.onOpen) === null || _props$onOpen === void 0 ? void 0 : _props$onOpen.call(props);
  };

  var close = function close() {
    if (opened.current) {
      (0, _interceptor.callInterceptor)({
        interceptor: props.beforeClose,
        args: ['close'],
        done: function done() {
          var _props$onClose;

          opened.current = false;
          (_props$onClose = props.onClose) === null || _props$onClose === void 0 ? void 0 : _props$onClose.call(props);
        }
      });
    }
  };

  var onClickOverlay = function onClickOverlay(event) {
    var _props$onClickOverlay;

    (_props$onClickOverlay = props.onClickOverlay) === null || _props$onClickOverlay === void 0 ? void 0 : _props$onClickOverlay.call(props, event);

    if (props.closeOnClickOverlay) {
      close();
    }
  };

  var renderOverlay = function renderOverlay() {
    if (props.overlay) {
      return /*#__PURE__*/_react().default.createElement(_overlay.default, {
        visible: visible && rendered,
        className: props.overlayClass,
        customStyle: props.overlayStyle,
        zIndex: zIndex.current,
        duration: duration,
        onClick: onClickOverlay
      });
    }

    return null;
  };

  var onClickCloseIcon = function onClickCloseIcon(e) {
    if (props.onClickCloseIcon) {
      props.onClickCloseIcon(e);
    }

    close();
  };

  var renderCloseIcon = function renderCloseIcon() {
    if (closeable) {
      var closeIconPosition = props.closeIconPosition;
      return /*#__PURE__*/_react().default.createElement(_icon.default, {
        name: closeIcon,
        className: (0, _classnames().default)(bem('close-icon', closeIconPosition)),
        classPrefix: props.iconPrefix,
        onClick: onClickCloseIcon
      });
    }

    return null;
  };

  var renderTitle = function renderTitle() {
    if (title) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('title'))
      }, title);
    }

    return null;
  };

  var renderDescrition = function renderDescrition() {
    if (descrition) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('descrition'))
      }, descrition);
    }

    return null;
  };

  var renderPopup = function renderPopup() {
    var safeAreaInsetBottom = props.safeAreaInsetBottom;
    return /*#__PURE__*/_react().default.createElement("div", {
      ref: popupRef,
      style: _objectSpread(_objectSpread({}, style), {}, {
        display: !visible && !animatedVisible ? 'none' : undefined
      }),
      className: (0, _classnames().default)(props.className, bem((0, _defineProperty2().default)({
        round: round
      }, position, position)), {
        'rc-safe-area-bottom': safeAreaInsetBottom
      }),
      onClick: props.onClick
    }, renderTitle(), renderDescrition(), children, renderCloseIcon());
  };

  var renderTransition = function renderTransition() {
    var transition = props.transition,
        destroyOnClose = props.destroyOnClose,
        forceRender = props.forceRender;
    var name = position === 'center' ? 'rc-fade' : "rc-popup-slide-".concat(position);
    return /*#__PURE__*/_react().default.createElement(_reactTransitionGroup().CSSTransition, {
      in: visible && rendered
      /**
       * https://github.com/reactjs/react-transition-group/pull/559
       */
      ,
      nodeRef: popupRef,
      timeout: duration,
      classNames: transition || name,
      mountOnEnter: !forceRender,
      unmountOnExit: destroyOnClose,
      onEnter: open,
      onEntered: props.onOpened,
      onExited: function onExited() {
        var _props$onClosed;

        setAnimatedVisible(false);
        (_props$onClosed = props.onClosed) === null || _props$onClosed === void 0 ? void 0 : _props$onClosed.call(props);
      }
    }, renderPopup());
  };

  (0, _useEventListener.default)('popstate', function () {
    if (props.closeOnPopstate) {
      close();
    }
  });
  (0, _react().useEffect)(function () {
    if (!rendered) return;

    if (visible) {
      lockScroll();
      setAnimatedVisible(true);
    } else {
      unlockScroll();
    }
  }, [visible, rendered]);
  (0, _react().useImperativeHandle)(ref, function () {
    return {
      popupRef: popupRef
    };
  });
  return ssrCompatRender(function () {
    return (0, _renderToContainer.renderToContainer)(props.teleport, /*#__PURE__*/_react().default.createElement(_PopupContext.default.Provider, {
      value: {
        visible: visible
      }
    }, renderOverlay(), renderTransition()));
  });
});
Popup.defaultProps = {
  zIndex: 2000,
  duration: 300,
  overlay: true,
  lockScroll: true,
  position: 'center',
  closeIcon: 'cross',
  closeIconPosition: 'top-right',
  closeOnClickOverlay: true,
  teleport: function teleport() {
    return document.body;
  }
};
var _default = Popup;
exports.default = _default;