"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

  _extends2 = function _extends2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _utils = require("../utils");

var _popup = _interopRequireDefault(require("../popup"));

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var PRESET_ICONS = ['qq', 'link', 'weibo', 'wechat', 'poster', 'qrcode', 'weapp-qrcode', 'wechat-moments'];

function getIconURL(icon) {
  if (PRESET_ICONS.includes(icon)) {
    return "https://img.yzcdn.cn/vant/share-sheet-".concat(icon, ".png");
  }

  return icon;
}

var ShareSheet = function ShareSheet(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('share-sheet', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var onCancel = function onCancel() {
    var _props$onCancel;

    (_props$onCancel = props.onCancel) === null || _props$onCancel === void 0 ? void 0 : _props$onCancel.call(props);
  };

  var onSelect = function onSelect(option, index) {
    var _props$onSelect;

    (_props$onSelect = props.onSelect) === null || _props$onSelect === void 0 ? void 0 : _props$onSelect.call(props, option, index);
  };

  var renderHeader = function renderHeader() {
    var title = props.title,
        description = props.description;

    if (title || description) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('header'))
      }, title && /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('title'))
      }, title), description && /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('description'))
      }, description));
    }

    return null;
  };

  var renderOption = function renderOption(option, index) {
    var name = option.name,
        icon = option.icon,
        className = option.className,
        description = option.description;
    return /*#__PURE__*/_react().default.createElement("div", {
      key: index,
      role: "button",
      tabIndex: 0,
      className: (0, _classnames().default)([bem('option'), className]),
      onClick: function onClick() {
        return onSelect(option, index);
      }
    }, /*#__PURE__*/_react().default.createElement("img", {
      alt: "share sheet icon",
      src: getIconURL(icon),
      className: (0, _classnames().default)(bem('icon'))
    }), name && /*#__PURE__*/_react().default.createElement("span", {
      className: (0, _classnames().default)(bem('name'))
    }, name), description && /*#__PURE__*/_react().default.createElement("span", {
      className: (0, _classnames().default)(bem('option-description'))
    }, description));
  };

  var renderOptions = function renderOptions(options, border, key) {
    return /*#__PURE__*/_react().default.createElement("div", {
      key: key,
      className: (0, _classnames().default)(bem('options', {
        border: border
      }))
    }, options.map(renderOption));
  };

  var renderRows = function renderRows() {
    var options = props.options;

    if (Array.isArray(options[0])) {
      return options.map(function (item, index) {
        return renderOptions(item, index !== 0, index);
      });
    }

    return renderOptions(options);
  };

  var renderCancelButton = function renderCancelButton() {
    var cancelText = props.cancelText;

    if (cancelText) {
      return /*#__PURE__*/_react().default.createElement("button", {
        type: "button",
        className: (0, _classnames().default)(bem('cancel')),
        onClick: onCancel
      }, cancelText);
    }

    return null;
  };

  return /*#__PURE__*/_react().default.createElement(_popup.default, (0, _extends2().default)({
    round: true,
    className: (0, _classnames().default)(bem()),
    position: "bottom",
    onClose: onCancel
  }, (0, _utils.pick)(props, ['closeOnPopstate', 'safeAreaInsetBottom', 'visible', 'overlay', 'duration', 'lockScroll', 'overlayStyle', 'overlayClass', 'closeOnClickOverlay'])), renderHeader(), renderRows(), renderCancelButton());
};

ShareSheet.defaultProps = {
  cancelText: '取消',
  options: [],
  closeOnPopstate: true,
  safeAreaInsetBottom: true,
  closeOnClickOverlay: true
};
var _default = ShareSheet;
exports.default = _default;