"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _objectWithoutProperties2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

  _objectWithoutProperties2 = function _objectWithoutProperties2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _utils = require("../utils");

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

var _excluded = ["children", "className", "style"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var DEFAULT_ROW_WIDTH = '100%';
var DEFAULT_LAST_ROW_WIDTH = '60%';

var Skeleton = function Skeleton(_ref) {
  var children = _ref.children,
      className = _ref.className,
      style = _ref.style,
      props = (0, _objectWithoutProperties2().default)(_ref, _excluded);

  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('skeleton', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var getRowWidth = function getRowWidth(index) {
    var rowWidth = props.rowWidth;

    if (rowWidth === DEFAULT_ROW_WIDTH && index === +props.row - 1) {
      return DEFAULT_LAST_ROW_WIDTH;
    }

    if (Array.isArray(rowWidth)) {
      return rowWidth[index];
    }

    return rowWidth;
  };

  var getRowHeight = function getRowHeight(index) {
    var rowHeight = props.rowHeight;

    if (Array.isArray(rowHeight)) {
      return rowHeight[index];
    }

    return rowHeight;
  };

  var renderAvatar = function renderAvatar() {
    if (props.avatar) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('avatar', props.avatarShape)),
        style: (0, _utils.getSizeStyle)(props.avatarSize)
      });
    }

    return null;
  };

  var renderTitle = function renderTitle() {
    if (props.title) {
      var width = (0, _utils.addUnit)(props.titleWidth);
      var height = (0, _utils.addUnit)(getRowHeight(0));
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('title')),
        style: {
          width: width,
          height: height
        }
      });
    }

    return null;
  };

  var renderRows = function renderRows() {
    return Array(props.row).fill('').map(function (_, i) {
      var width = (0, _utils.addUnit)(getRowWidth(i));
      var height = (0, _utils.addUnit)(getRowHeight(i)); // eslint-disable-next-line react/no-array-index-key

      return /*#__PURE__*/_react().default.createElement("div", {
        key: i,
        className: (0, _classnames().default)(bem('row')),
        style: {
          width: width,
          height: height
        }
      });
    });
  };

  if (!props.loading) return children;
  return /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(className, bem({
      animate: props.animate,
      round: props.round
    })),
    style: style
  }, renderAvatar(), /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('content'))
  }, renderTitle(), renderRows()));
};

Skeleton.defaultProps = {
  loading: true,
  animate: true,
  round: true,
  row: 3,
  avatarShape: 'round',
  rowWidth: DEFAULT_ROW_WIDTH
};
var _default = Skeleton;
exports.default = _default;