"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _objectWithoutProperties2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

  _objectWithoutProperties2 = function _objectWithoutProperties2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _constant = require("../utils/constant");

var _icon = _interopRequireDefault(require("../icon"));

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

var _excluded = ["children"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var StepsItem = function StepsItem(_ref) {
  var children = _ref.children,
      props = (0, _objectWithoutProperties2().default)(_ref, _excluded);
  var index = props.index,
      parentProps = props.parent;

  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('step', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  if (!parentProps) {
    if (process.env.NODE_ENV !== 'production') {
      // eslint-disable-next-line no-console
      console.error('[rc-ui-lib] <Step> must be a child component of <Steps>.');
    }
  }

  var getStatus = function getStatus() {
    var active = +parentProps.active;

    if (index < active) {
      return 'finish';
    }

    return index === active ? 'process' : 'waiting';
  };

  var isActive = function isActive() {
    return getStatus() === 'process';
  };

  var lineStyle = (0, _react().useMemo)(function () {
    return {
      background: getStatus() === 'finish' ? parentProps.activeColor : parentProps.inactiveColor
    };
  }, [index, parentProps.active, parentProps.activeColor, parentProps.inactiveColor]);
  var titleStyle = (0, _react().useMemo)(function () {
    if (isActive()) {
      return {
        color: parentProps.activeColor
      };
    }

    if (!getStatus()) {
      return {
        color: parentProps.inactiveColor
      };
    }

    return {};
  }, [index, parentProps.active, parentProps.activeColor, parentProps.inactiveColor]);

  var onClickStep = function onClickStep() {
    if (parentProps.onClickStep) parentProps.onClickStep(index);
  };

  var renderCircle = function renderCircle() {
    var iconPrefix = parentProps.iconPrefix,
        finishIcon = parentProps.finishIcon,
        activeIcon = parentProps.activeIcon,
        activeColor = parentProps.activeColor,
        inactiveIcon = parentProps.inactiveIcon;

    if (isActive()) {
      if ( /*#__PURE__*/_react().default.isValidElement(parentProps.activeIcon)) {
        return parentProps.activeIcon;
      }

      return /*#__PURE__*/_react().default.createElement(_icon.default, {
        className: (0, _classnames().default)(bem('icon', 'active')),
        name: activeIcon,
        color: activeColor,
        classPrefix: iconPrefix
      });
    }

    if (getStatus() === 'finish' && (finishIcon || /*#__PURE__*/_react().default.isValidElement(parentProps.finishIcon))) {
      if ( /*#__PURE__*/_react().default.isValidElement(parentProps.finishIcon)) {
        return parentProps.finishIcon;
      }

      return /*#__PURE__*/_react().default.createElement(_icon.default, {
        className: (0, _classnames().default)(bem('icon', 'finish')),
        name: finishIcon,
        color: activeColor,
        classPrefix: iconPrefix
      });
    }

    if ( /*#__PURE__*/_react().default.isValidElement(parentProps.inactiveIcon)) {
      return parentProps.inactiveIcon;
    }

    if (inactiveIcon) {
      return /*#__PURE__*/_react().default.createElement(_icon.default, {
        className: (0, _classnames().default)(bem('icon')),
        name: inactiveIcon,
        classPrefix: iconPrefix
      });
    }

    return /*#__PURE__*/_react().default.createElement("i", {
      className: (0, _classnames().default)(bem('circle')),
      style: lineStyle
    });
  };

  var status = getStatus();
  return /*#__PURE__*/_react().default.createElement("div", {
    style: props.style,
    className: (0, _classnames().default)(props.className, _constant.BORDER, bem([parentProps.direction, (0, _defineProperty2().default)({}, status, status)]))
  }, /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('title', {
      active: isActive()
    })),
    style: titleStyle,
    onClick: onClickStep
  }, children), /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('circle-container')),
    onClick: onClickStep
  }, renderCircle()), /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('line')),
    style: lineStyle
  }));
};

var _default = StepsItem;
exports.default = _default;