"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

  _extends2 = function _extends2() {
    return data;
  };

  return data;
}

function _objectWithoutProperties2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

  _objectWithoutProperties2 = function _objectWithoutProperties2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

function _swiper() {
  var data = _interopRequireWildcard(require("swiper"));

  _swiper = function _swiper() {
    return data;
  };

  return data;
}

function _react2() {
  var data = require("swiper/react");

  _react2 = function _react2() {
    return data;
  };

  return data;
}

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

var _excluded = ["children", "className", "autoplay"],
    _excluded2 = ["initialSwipe", "duration", "onChange", "vertical", "showIndicators"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

_swiper().default.use([_swiper().Autoplay, _swiper().Pagination, _swiper().Lazy]);

var Swipe = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('swipe', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var _parseOptions = parseOptions(props),
      children = _parseOptions.children,
      className = _parseOptions.className,
      autoplay = _parseOptions.autoplay,
      otherProps = (0, _objectWithoutProperties2().default)(_parseOptions, _excluded);

  var internalSwipeRef = (0, _react().useRef)(null);
  (0, _react().useImperativeHandle)(ref, function () {
    return internalSwipeRef.current;
  }, [internalSwipeRef.current]);
  return /*#__PURE__*/_react().default.createElement(_react2().Swiper, (0, _extends2().default)({
    className: (0, _classnames().default)(className, bem()),
    onSwiper: function onSwiper(swiper) {
      internalSwipeRef.current = swiper;
    },
    autoplay: autoplay
  }, otherProps), _react().Children.toArray(children).filter(Boolean).map(function (child) {
    return /*#__PURE__*/(0, _react().cloneElement)(child, {
      className: 'rc-swipe-item'
    });
  }));
});
Swipe.defaultProps = {
  initialSwipe: 0,
  duration: 500,
  pagination: true
};

function parseOptions(opts) {
  var initialSwipe = opts.initialSwipe,
      duration = opts.duration,
      onChange = opts.onChange,
      vertical = opts.vertical,
      showIndicators = opts.showIndicators,
      rest = (0, _objectWithoutProperties2().default)(opts, _excluded2);

  if (vertical) {
    rest.direction = 'vertical';
  }

  if (typeof showIndicators === 'boolean') {
    if (!showIndicators) rest.pagination = false;
  }

  rest.initialSlide = initialSwipe;
  rest.speed = duration;

  if (rest.autoplay && typeof rest.autoplay === 'number') {
    rest.autoplay = {
      delay: rest.autoplay,
      disableOnInteraction: false
    };
  }

  if (onChange) {
    rest.onSlideChange = function (sw) {
      var idx = opts.loop ? sw.realIndex : sw.activeIndex;
      onChange === null || onChange === void 0 ? void 0 : onChange(idx);
    };
  }

  return rest;
}

var _default = Swipe;
exports.default = _default;