"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _useMergedState3 = _interopRequireDefault(require("../hooks/use-merged-state"));

var _loading = _interopRequireDefault(require("../loading"));

var _utils = require("../utils");

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Swtich = function Swtich(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('switch', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var loading = props.loading,
      disabled = props.disabled,
      size = props.size,
      activeColor = props.activeColor,
      inactiveColor = props.inactiveColor;

  var _useMergedState = (0, _useMergedState3.default)({
    value: props.checked,
    defaultValue: props.defaultChecked
  }),
      _useMergedState2 = (0, _slicedToArray2().default)(_useMergedState, 2),
      checked = _useMergedState2[0],
      setChecked = _useMergedState2[1];

  var isChecked = (0, _react().useMemo)(function () {
    return checked === props.activeValue;
  }, [checked, props.activeValue]);

  var style = _objectSpread({
    fontSize: (0, _utils.addUnit)(size),
    backgroundColor: isChecked ? activeColor : inactiveColor
  }, props.style);

  var onClick = function onClick(e) {
    if (!props.disabled) {
      var _props$onClick;

      (_props$onClick = props.onClick) === null || _props$onClick === void 0 ? void 0 : _props$onClick.call(props, e);
    }

    if (!props.disabled && !props.loading) {
      var _props$onChange;

      var newValue = isChecked ? props.inactiveValue : props.activeValue;
      setChecked(newValue);
      (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, newValue);
    }
  };

  var renderLoading = function renderLoading() {
    if (props.loading) {
      var color = isChecked ? props.activeColor : props.inactiveColor;
      return /*#__PURE__*/_react().default.createElement(_loading.default, {
        className: (0, _classnames().default)(bem('loading')),
        color: color
      });
    }

    return null;
  };

  return /*#__PURE__*/_react().default.createElement("div", {
    role: "switch",
    tabIndex: 0,
    className: (0, _classnames().default)(props.className, bem({
      on: isChecked,
      loading: loading,
      disabled: disabled
    })),
    style: style,
    "aria-checked": isChecked,
    onClick: onClick
  }, /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('node'))
  }, renderLoading()));
};

Swtich.defaultProps = {
  activeValue: true,
  inactiveValue: false
};
var _default = Swtich;
exports.default = _default;