"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames2() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames2 = function _classnames2() {
    return data;
  };

  return data;
}

var _utils = require("../utils");

var _constant = require("../utils/constant");

var _useHeight = _interopRequireDefault(require("../hooks/use-height"));

var _TabbarContext = _interopRequireDefault(require("./TabbarContext"));

var _useMergedState3 = _interopRequireDefault(require("../hooks/use-merged-state"));

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Tabbar = function Tabbar(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('tabbar', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var _useMergedState = (0, _useMergedState3.default)({
    value: props.value,
    defaultValue: props.defaultValue
  }),
      _useMergedState2 = (0, _slicedToArray2().default)(_useMergedState, 2),
      current = _useMergedState2[0],
      setCurrent = _useMergedState2[1];

  var root = (0, _react().useRef)();
  var height = (0, _useHeight.default)(root);

  var renderPlaceholder = function renderPlaceholder(renderContent) {
    return /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames2().default)(bem('placeholder')),
      style: {
        height: height
      }
    }, renderContent());
  }; // enable safe-area-inset-bottom by default when fixed


  var enableSafeArea = function enableSafeArea() {
    var _props$safeAreaInsetB;

    return (_props$safeAreaInsetB = props.safeAreaInsetBottom) !== null && _props$safeAreaInsetB !== void 0 ? _props$safeAreaInsetB : props.fixed;
  };

  var setActive = function setActive(active) {
    if (active !== props.value) {
      var _props$onChange;

      (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, active);
      setCurrent(active);
    }
  };

  var renderTabbar = function renderTabbar() {
    var _classnames;

    var fixed = props.fixed,
        zIndex = props.zIndex,
        border = props.border;
    return /*#__PURE__*/_react().default.createElement(_TabbarContext.default.Provider, {
      value: {
        parent: _objectSpread(_objectSpread({}, props), {}, {
          value: current
        })
      }
    }, /*#__PURE__*/_react().default.createElement("div", {
      ref: root,
      style: _objectSpread(_objectSpread({}, props.style), (0, _utils.getZIndexStyle)(zIndex)),
      className: (0, _classnames2().default)(props.className, bem({
        fixed: fixed
      }), (_classnames = {}, (0, _defineProperty2().default)(_classnames, _constant.BORDER_TOP_BOTTOM, border), (0, _defineProperty2().default)(_classnames, 'rc-safe-area-bottom', enableSafeArea()), _classnames))
    }, _react().default.Children.toArray(props.children).filter(Boolean).map(function (child, index) {
      return /*#__PURE__*/_react().default.cloneElement(child, {
        setActive: setActive,
        index: index
      });
    })));
  };

  if (props.fixed && props.placeholder) {
    return renderPlaceholder(renderTabbar);
  }

  return renderTabbar();
};

Tabbar.defaultProps = {
  fixed: true,
  border: true,
  defaultValue: 0
};
var _default = Tabbar;
exports.default = _default;