"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _TabsContext = _interopRequireDefault(require("./TabsContext"));

var _hooks = require("../hooks");

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var TabPane = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('tab', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var parent = (0, _react().useContext)(_TabsContext.default);

  var _useState = (0, _react().useState)(false),
      _useState2 = (0, _slicedToArray2().default)(_useState, 2),
      inited = _useState2[0],
      setInited = _useState2[1];

  var _parent$props = parent.props,
      animated = _parent$props.animated,
      swipeable = _parent$props.swipeable,
      scrollspy = _parent$props.scrollspy,
      lazyRender = _parent$props.lazyRender;
  var index = props.index;

  var getName = function getName() {
    var _props$name;

    return (_props$name = props.name) !== null && _props$name !== void 0 ? _props$name : index;
  };

  var init = function init() {
    setInited(true);
  };

  var isActive = (0, _react().useMemo)(function () {
    var active = getName() === parent.currentName;

    if (active && !inited) {
      init();
    }

    return active;
  }, [inited, parent.currentName]);
  (0, _hooks.useUpdateEffect)(function () {
    parent.setLine();
    parent.scrollIntoView();
  }, [props.title]);
  var show = scrollspy || isActive;

  if (animated || swipeable) {
    return /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(bem('pane'))
    }, props.children);
  }

  var shouldRender = inited || scrollspy || !lazyRender;
  var Content = shouldRender ? props.children : null;
  return /*#__PURE__*/_react().default.createElement("div", {
    ref: ref,
    style: {
      display: show ? 'block' : 'none'
    },
    role: "tabpanel",
    className: (0, _classnames().default)(bem('pane'))
  }, Content);
});
TabPane.defaultProps = {
  showZeroBadge: true
};
var _default = TabPane;
exports.default = _default;